float contourmap;
vec2 xy;
vec2 xyoffset;
vec2 depthcurved;

void main()
{
	vec4 colour = texture(InputTexture, TexCoord);
	if (colour.g < 0.51 && colour.r > tolerance && colour.b > tolerance)
	{
		contourmap = (colour.g - 0.0556) * 2 * contour;
		colour.g = 0;
		xy = vec2(TexCoord.x, TexCoord.y);
		/*xyoffset = (xy - 0.5) * 2;				//increase range from [0.0 -> 1.0] to [-1.0 -> 1.0] so 0.5 becomes 0.0 and is unaffected by multiplication
		depthcurved = 1 + ((depth - 1) * (1 - abs(xyoffset)));	//diminish 'depth' level toward screen edges
		
		//pinch/punch effect
		if (xyoffset.x < 0)
		{
			xy.x = 0 - pow(xyoffset.x, depthcurved.x);
		}
		else
		{
			xy.x = pow(xyoffset.x, depthcurved.x);
		}
		
		if (xyoffset.y < 0)
		{
			xy.y = 0 - pow(xyoffset.y, depthcurved.y);
		}
		else
		{
			xy.y = pow(xyoffset.y, depthcurved.y);
		}
		/*
		if (hflip == 1)
		{
			xy.x = 1 - xy.x;
		}
		if (vflip == 1)
		{
			xy.y = 1 - xy.y;
		}
		*/
		colour = texture(InputTexture, xy * (1 - contourmap));// * 0.5 + 0.5);	//"* 0.5 + 0.5" is to bring [-1.0 -> 1.0] back to [0.0 -> 1.0] and 0.0 returns to 0.5
		
		if (colour.g < colour.r && colour.r > colour.g && colour.b > colour.g)
		{
			colour.rb -= 0.9;	//remove magenta (already reduced %10 by alpha)
			colour.rb *= 10;	//amplify remaining background content up to %100
			if ((colour.r + colour.b) / 2 > 0.89)
			{
				colour = 1 - colour;
			}
			colour.g = (colour.r + colour.b) * 0.5;	//green adopts the average of red and blue
		}
		//colour = colour + brightness - (((1 - negshading) * contourmap) * shading);
		/*
		if (negative == 1)
		{
			colour = 1 - colour;
		}*/
	}
	FragColor = colour;
}